from keysql_client.keysql_statement_type_object import StatementType, StatementObj

class MessageHeader:

    def __init__(self, msg_id=0, format='keysql'):
        self._id = msg_id
        self.message_format = format

    def out_msg(self, msg_len : int):
        out = str(msg_len)
        out += " "
        out += str(self._id)
        out += " 0"
        out += ' format ' + self.message_format
        out += " \n"

        return out

    @staticmethod
    def unpack(msg):
        header = {}
        parts = msg.split(" ")
        for i in range(0, 3):
            if i == 0:
                header["message_length"] = int(parts[i])
            elif i == 1:
                header["id"] = int(parts[i])
            elif i == 2:
                header["exit_code"] = int(parts[i])

        header["query"] = 0
        for i in range(3, len(parts)-1, 2):
            key_value = parts[i]
            if key_value == "type":
                header["statement_type"] = StatementType(int(parts[i + 1]))
            elif key_value == "count":
                header["instance_count"] = int(parts[i+1])
            elif key_value == "page":
                header["page"] = int(parts[i+1])
            elif key_value == "query":
                header["query"] = int(parts[i + 1])
            elif key_value == "format":
                header["format"] = parts[i+1]
            elif key_value == "encoding":
                header["encoding"] = parts[i+1]
            elif key_value == "time":
                header["time"] = float(parts[i+1])
            elif key_value == "src":
                header["statement_obj"] = StatementObj(int(parts[i + 1]))

        header['err_message'] = ''
        return header
